import { DeviceResponseType } from "../Devices/IDevice";
export class DeviceStateArgument {
    constructor() {
        this._comparisonParams = new Map();
        this.Type = DeviceResponseType.Unknown;
        this.DeviceGuid = "";
        this.ComparisonMethod = DeviceStateComparisonMethod.Default;
    }
    GetCheckDeviceState() {
        return this._checkDeviceState;
    }
    SetCheckDeviceState(state) {
        this._checkDeviceState = state;
    }
    GetComparisonParam(comparisonParam) {
        return this._comparisonParams.get(comparisonParam);
    }
    GetComparisonParams() {
        return this._comparisonParams;
    }
    SetComparisonParam(comparisonParam, value) {
        this._comparisonParams.set(comparisonParam, value);
    }
}
export class NumberParam {
    constructor(val) {
        this._value = val;
    }
    get Value() {
        return this._value;
    }
    set Value(val) {
        this._value = val;
    }
}
export class TimeSpanParam {
    constructor(...args) {
        this._value = "00:00:00";
        if (args.length > 1)
            this.SetTimeSpan(args[0], args[1], args[2], args[3]);
        else
            this._value = args[0];
    }
    SetTimeSpan(seconds, minutes, hours, days) {
        if (days <= 0)
            this._value = `${hours.toString().padStart(2, '0')}:${minutes.toString().padStart(2, '0')}:${seconds.toString().padStart(2, '0')}`;
        else
            this._value = `${days}.${hours.toString().padStart(2, '0')}:${minutes.toString().padStart(2, '0')}:${seconds.toString().padStart(2, '0')}`;
    }
    get Value() {
        return this._value;
    }
}
export var DeviceStateComparisonMethod;
(function (DeviceStateComparisonMethod) {
    DeviceStateComparisonMethod[DeviceStateComparisonMethod["Default"] = 0] = "Default";
    DeviceStateComparisonMethod[DeviceStateComparisonMethod["Delta"] = 1] = "Delta";
    DeviceStateComparisonMethod[DeviceStateComparisonMethod["StateRepeat"] = 2] = "StateRepeat";
})(DeviceStateComparisonMethod || (DeviceStateComparisonMethod = {}));
export var DeviceStateComparisonParams;
(function (DeviceStateComparisonParams) {
    DeviceStateComparisonParams[DeviceStateComparisonParams["DeltaValue"] = 0] = "DeltaValue";
    DeviceStateComparisonParams[DeviceStateComparisonParams["DeltaCalculationTimeRange"] = 1] = "DeltaCalculationTimeRange";
    DeviceStateComparisonParams[DeviceStateComparisonParams["StateRepeatCount"] = 2] = "StateRepeatCount";
    DeviceStateComparisonParams[DeviceStateComparisonParams["StateRepeatTimeRange"] = 3] = "StateRepeatTimeRange";
})(DeviceStateComparisonParams || (DeviceStateComparisonParams = {}));
export class AstronomicalClockArgument {
    constructor() {
        this.Position = SunPosition.SunRise;
    }
}
export class AstronomicalClockWithOffsetArgument {
    constructor() {
        this.Position = SunPosition.SunRise;
        this.Offset = 0;
    }
}
export var SunPosition;
(function (SunPosition) {
    SunPosition[SunPosition["SunRise"] = 1] = "SunRise";
    SunPosition[SunPosition["SunSet"] = 2] = "SunSet";
})(SunPosition || (SunPosition = {}));
export class TimeArgument {
    constructor(seconds, minutes, hours) {
        this.Hour = 0;
        this.Minute = 0;
        this.Second = 0;
        if (seconds && minutes && hours) {
            this.Hour = hours;
            this.Minute = minutes;
            this.Second = seconds;
        }
    }
}
export class SimpleTimeSpanArgument {
    constructor(seconds, minutes, hours, days) {
        this.hours = 0;
        this.minutes = 0;
        this.seconds = 0;
        this.days = 0;
        if (seconds && minutes && hours && days) {
            this.days = days;
            this.hours = hours;
            this.minutes = minutes;
            this.seconds = seconds;
        }
    }
}
export class ConditionInfoArgument {
    constructor() {
        this.DeviceGuid = "";
    }
}
//# sourceMappingURL=LeftArgumentTypes.js.map